#+TITLE: Light markup for babel (LaTeX) commands

* Test

%(de) Goldner Schlaf, nur dessen Herz zufrieden %()

%(fr) relation, de nature indéterminée, entre ces deux textes %()

%(--esperanto) Ne venas mont' al monto, sed homo homon renkontas. %()

%(--latin) In uitium ducit culpae fuga, si caret arte. %()

Escaped versions

;%(de) Goldner Schlaf, nur dessen Herz zufrieden %()

;%(fr) relation, de nature indéterminée, entre ces deux textes %()

;%(--esperanto) Ne venas mont' al monto, sed homo homon renkontas. %()

;%(--latin) In uitium ducit culpae fuga, si caret arte. %()

* Code

#+BIND: org-export-filter-final-output-functions (my-latex-babel-filter)

#+begin_src emacs-lisp :exports results :results none
  (defun my-latex-babel-filter (text backend info)
    (cond ((org-export-derived-backend-p backend 'latex)
	   (with-temp-buffer
	     (insert text)
	     (let* ((langs '(("en" "english")
			     ("fr" "french")
			     ("de" "german")
			     ("it" "italian")
			     ("ru" "russian")
			     ("el" "greek")
			     ("pt" "portuguese"))))
	       ;; babel LaTeX
	       (save-excursion
		 (goto-char (point-min))
		 (while (re-search-forward "\\(;*\\)\\(\\\\%(\\)\\([^()\s]+\\)\\()\\)\\(\s*\n*\s*\\)" nil t)
		   (if (equal (match-string 1) "")
		       (progn
			 (replace-match (concat
					 "\\\\foreingnlanguage{"
					 (if (string-match-p "--" (match-string 3))
					     (replace-regexp-in-string "--" "" (match-string 3))
					   (nth 1 (assoc (match-string 3) langs)))
					 "}{"))
			 (re-search-forward "\\(\s*\n*\s*\\)\\\\%()" nil t)
			 (replace-match "}"))
		     (replace-match "\\2\\3\\4\\5"))))
	       (setq text (buffer-string)))))
	  ;;  html and odt
	  ((or (org-export-derived-backend-p backend 'html)
	       (org-export-derived-backend-p backend 'odt))
	   (with-temp-buffer
	     (insert text)
	     ;; remove babel
	     (save-excursion
	       (goto-char (point-min))
	       (while (re-search-forward "\\(;*\\)\\(%(\\)\\([^()\s]+\\)\\()\\)\\(\s*\n*\s*\\)" nil t)
		 (if (equal (match-string 1) "")
		     (progn
		       (replace-match "")
		       (re-search-forward "\\(\s*\n*\s*\\)%()" nil t)
		       (replace-match ""))
		   (replace-match "\\2\\3\\4\\5"))))
	     (setq text (buffer-string))))))
#+end_src
